#ifndef AIRWAY_SEG_H
#define AIRWAY_SEG_H
#include <stack>

typedef struct Tubeness {
    float *value, *Fx, *Fy, *Fz, *radius;
} Tubeness;

typedef struct float3 {
    float x,y,z;
} float3;

typedef struct int3 {
    int x,y,z;
} int3;

typedef struct CenterlinePoint {
    int3 pos;
    CenterlinePoint * next;
} CenterlinePoint;

Tubeness runCircleFittingTDF(short * HUvolume, float Fmax, float sigma, float rMin, float rMax, int SIZE_X, int SIZE_Y, int SIZE_Z, int HUthreshold, int HUminimum, int ITERATIONS, float MU) ;

int * runCenterlineExtraction(Tubeness T, float Thigh, int SIZE_X, int SIZE_Y, int SIZE_Z, std::stack<CenterlinePoint> *centerlineStack);

char * runInverseGradientSegmentation(Tubeness T, std::stack<CenterlinePoint> centerline, int SIZE_X, int SIZE_Y, int SIZE_Z);

char * runCircleSegmentation(Tubeness T, std::stack<CenterlinePoint> centerline, int SIZE_X, int SIZE_Y, int SIZE_Z);
#endif
