#include "airway-segmentation.hpp"
#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include "rawFiles.hpp"

int main(int argc, char ** argv) {
    int SIZE_X;
    int SIZE_Y;
    int SIZE_Z;
    std::cout << "Reading raw file.." << std::endl;
    short * dataset = parseRawFile(argv[1], &SIZE_X, &SIZE_Y, &SIZE_Z);
    //short * dataset = parseRawFile("/home/smistad/Storage/Pasienter/Pasient 3/CT_patient_003.mhd", &SIZE_X, &SIZE_Y, &SIZE_Z);
    std::cout << "Raw file read." << std::endl;
    std::cout << "Performing cropping of dataset..." << std::endl;
    short * HUvolume = lungCropping(dataset, &SIZE_X, &SIZE_Y, &SIZE_Z);
    writeToRaw<short>(HUvolume, "/home/smistad/cropped.raw", SIZE_X, SIZE_Y, SIZE_Z);
    std::cout << "Cropping performed. New size: " << SIZE_X << ", " << SIZE_Y << ", " << SIZE_Z << std::endl;
    delete[] dataset;
    runCircleFittingTDF(HUvolume, 0.15, 1.0, 1.0, 25.0, SIZE_X, SIZE_Y, SIZE_Z, -100, -1024, 500, 0.05f); // Pas 1
    //runCircleFittingTDF(0.2, 1.0, 0.5, 15.0, &SIZE_X, &SIZE_Y, &SIZE_Z, -100, -1024, 400, 0.05f); // pas 5


    // Read T, Fx, Fy and Fz from disk
    Tubeness T;
    T.value = new float[SIZE_X*SIZE_Y*SIZE_Z];
    T.radius = new float[SIZE_X*SIZE_Y*SIZE_Z];
    T.Fx = new float[SIZE_X*SIZE_Y*SIZE_Z];
    T.Fy = new float[SIZE_X*SIZE_Y*SIZE_Z];
    T.Fz = new float[SIZE_X*SIZE_Y*SIZE_Z];

    FILE * tFile = fopen("/home/smistad/output.raw", "rb");
    fread(T.value, sizeof(float), SIZE_X*SIZE_Y*SIZE_Z, tFile);
    fclose(tFile);

    FILE * rFile = fopen("/home/smistad/radius.raw", "rb");
    fread(T.radius, sizeof(float), SIZE_X*SIZE_Y*SIZE_Z, rFile);
    fclose(rFile);
    
    FILE * fFile = fopen("/home/smistad/gvf.raw", "rb");
    float * tmp = new float[SIZE_X*SIZE_Y*SIZE_Z*3];
    fread(tmp, sizeof(float), SIZE_X*SIZE_Y*SIZE_Z*3, fFile);
    fclose(fFile);
    for(int i = 0; i < SIZE_X*SIZE_Y*SIZE_Z; i++) {
        T.Fx[i] = tmp[i*3];
        T.Fy[i] = tmp[i*3+1];
        T.Fz[i] = tmp[i*3+2];
    }
    free(tmp);

    std::stack<CenterlinePoint> centerlineStack;
    int * centerline = runCenterlineExtraction(T, 0.6, SIZE_X, SIZE_Y, SIZE_Z, &centerlineStack);
    // Write centerline to disk
    FILE * file = fopen("/home/smistad/centerline.raw", "wb");
    fwrite(centerline, sizeof(int), SIZE_X*SIZE_Y*SIZE_Z, file);
    fclose(file);

    // Run inverse gradient segmentation on centerline
    char * segmentation = runInverseGradientSegmentation(T, centerlineStack, SIZE_X, SIZE_Y, SIZE_Z);
    //char * segmentation = runCircleSegmentation(T, centerlineStack, SIZE_X, SIZE_Y, SIZE_Z);
    
    file = fopen("/home/smistad/segmentation.raw", "wb");
    fwrite(segmentation, sizeof(char), SIZE_X*SIZE_Y*SIZE_Z, file);
    fclose(file);

    return 0;
}
